angular.module('starter.controllers')

.controller('AuditCtrl', ['$scope', '$http', '$ls', '$state', 'sync', '$ionicLoading', '$timeout', '$filter', 'u', function($scope, $http, $ls, $state, sync, $ionicLoading, $timeout, $filter, u) {

	function _init() {
		$scope.location = u.getLocation();
		$scope.locationId = $scope.location.id;
		$scope.audits = [];

		var allAudits = $ls.getArray('audits');
		$scope.audit_templates = $ls.getArray('audit_templates');
		
		if(allAudits.length) {
			var audits = [];
			angular.forEach(allAudits, function(audit) {
				var company_id = String(audit.company_id);
				var locationId = String($scope.locationId);

				if (company_id === locationId) {
					audits.push(audit);
				}
			});

			$scope.audits = $filter('orderBy')(audits, 'timestamp', true);
		}
	
	}

	$scope.goToAudit = function(audit) {
		var audit_id = audit.id ? audit.id : audit.guid;
		$state.go('app.editaudit', {id: audit_id});
	}

	$scope.$on('syncComplete', function() {
		$timeout(function(){
			$scope.$apply(function(){
				_init();
			});
		});
	});

	$scope.newAudit = function() {
		$state.go('app.newaudit');
	};

	_init();

}]);