angular.module('starter.controllers')

.controller('AuditInfoCtrl', ['$scope', '$http', '$ls', '$state', 'u', '$filter', 'sync', function($scope, $http, $ls, $state, u, $filter, sync) {

	var audit_id = String($state.params.id);
	$scope.audit = u.findAudit(audit_id);

	$scope.currentLocation = u.getLocation();
	$scope.isEastBalt = u.isEastBalt($scope.currentLocation);
	$scope.showEastBaltStuff = false;

	var template = u.findTemplate($scope.audit.audit_template_id);
	if (template.name.match(/^bun|muffin/i)) {
		$scope.showEastBaltStuff = true;
	}

  $scope.updatedAudit = angular.copy($scope.audit);
  var ts = $scope.updatedAudit.date;
  var ts = ts + '000';
  var fd = $filter('date')(ts, 'M/d/yyyy');
  $scope.updatedAudit.formattedDate = fd;

  $scope.$watch('updatedAudit.formattedDate', _updateAudit);
  $scope.$watch('updatedAudit.time', _updateAudit);
  $scope.$watch('updatedAudit.department', _updateAudit);
  $scope.$watch('updatedAudit.notes', _updateAudit);

  function _updateAudit() {
    var ts = Date.parse($scope.updatedAudit.formattedDate);
    ts = ts / 1000;
    ts = Math.round(ts);
    $scope.audit.time = angular.copy($scope.updatedAudit.time);
    $scope.audit.department = angular.copy($scope.updatedAudit.department);
    $scope.audit.notes = angular.copy($scope.updatedAudit.notes);
    $scope.audit.date = ts;
		sync.updateAudit($scope.audit);
  }

}]);