angular.module('starter.controllers')

.controller('DataCtrl', ['$scope', '$http', '$ls', '$state', 'sync', '$ionicLoading', 'u', '$location', '$ionicPopup', function($scope, $http, $ls, $state, sync, $ionicLoading, u, $location, $ionicPopup) {

	$scope.settings = {
		reset: false
	};

	_resetData = function() {
		sync.resetAll().then(function(){
			$scope.settings.reset = false;
		});
	}

	$scope.showConfirm = function() {
		if ($scope.settings.reset !== true) {
			return;
		}

		var confirmPopup = $ionicPopup.confirm({
			title: 'Reset app data',
			template: 'Are you sure you want to reset audit data? This cannot be undone.',
			buttons: [
				{ text: 'Cancel' },
				{
					text: '<b>Reset Audit Data</b>',
					type: 'button-assertive',
					onTap: function(e) {
						return true;
					}
				}
			]
		});
		confirmPopup.then(function(res) {
			if(res) {
				_resetData();
			} else {
				$scope.settings.reset = false;
			}
		});
	};

	//Cleanup the modal when we're done with it!
	$scope.$on('$destroy', function() {
		if ($scope.pinModal) {
			$scope.pinModal.remove();
		}
	});


}]);