angular.module('starter.controllers')

.controller('NewAuditCtrl', ['$scope', '$http', '$ls', '$filter', 'u', '$state', function($scope, $http, $ls, $filter, u, $state) {

	$scope.user = $ls.getObject('user');
	$scope.currentLocation = u.getLocation();
	$scope.isEastBalt = u.isEastBalt($scope.currentLocation);
	$scope.showEastBaltStuff = false;
	$scope.audit_templates = $ls.getArray('audit_templates');

	function filterTemplates() {
		if ($scope.user.user_group !== 'Evaluators') {
			return;
		}

		var templates = [];
		angular.forEach($scope.audit_templates, function(audit_template) {
			if (audit_template.name.match(/bun/i) || audit_template.name.match(/muffin/i)) {
				templates.push(audit_template);
			}
		});

		$scope.audit_templates = templates;
	}

	$scope.addAudit = function() {
		if ($scope.newAudit.audit_template_id && $scope.newAudit.formattedDate && $scope.newAudit.time) {

			var audit = angular.copy($scope.newAudit);
			audit.guid = u.guid();

			if ($scope.showEastBaltStuff === true) {
				if (!$scope.newAudit.formattedUsedThroughDate || !$scope.newAudit.fresh_frozen || !$scope.newAudit.production_hour || !$scope.newAudit.line_type) {
					return;
				}
			}

	    var ts = Date.parse($scope.newAudit.formattedDate);
	    ts = ts / 1000;
	    ts = Math.round(ts);
			audit.date = ts;

			audit.edited = true;
			audit.updated = 1;
			audit.updated_at = u.phpts();
			angular.forEach($scope.audit_templates, function(template){
				if (audit.audit_template_id === template.id || parseInt(audit.audit_template_id) === template.id) {
					audit.type = template.name;
				}
			});

			if ($scope.user.user_group === 'Evaluators') {
		    var ts = Date.parse($scope.newAudit.formattedUsedThroughDate);
		    ts = ts / 1000;
		    ts = Math.round(ts);
				audit.use_through_date = ts;
			}

			var audits = $ls.getArray('audits');
			audits.unshift(audit);

			$ls.setArray('audits', audits);
			$ls.set('needToSync', true);

			$scope.$root.needToSync = true;

			$state.go('app.editaudit', {id: audit.guid});
		}
	}

	$scope.refresh_audit_templates = function() {
		$http.get($scope.$root.uri + '/audit_template').
			success(function(data) {
				$ls.setArray('audit_templates', data);
				$scope.audit_templates = data;
				filterTemplates();
			});
	}

	$scope.updateTemplate = function() {
		if ($scope.isEastBalt !== true) {
			return;
		}

		var template = u.findTemplate($scope.newAudit.audit_template_id);
		if (template.name.match(/^bun|muffin/i)) {
			$scope.showEastBaltStuff = true;
		}
	}

	if (!$scope.audit_templates) {
		$scope.refresh_audit_templates();
	}

	var now = new Date();

	$scope.newAudit = {
		audit_template_id: null,
		company_id: $ls.get('locationId'),
		formattedDate: $filter('date')(now, 'MMM d yyyy'),
		time: $filter('date')(now, 'h:mm a'),
		department: null,
		timestamp: now.getTime() / 1000,
		answers: {},
		comments: {},
		actions: {},
		images: {}
	};

	if ($scope.user.user_group === 'Evaluators') {
		$scope.newAudit.formattedUsedThroughDate = $filter('date')(now, 'MMM d yyyy');
		$scope.newAudit.store_number = null;
		$scope.newAudit.fresh_frozen = null;
		$scope.newAudit.use_through_date = null;
		$scope.newAudit.production_hour = null;
		$scope.newAudit.line_type = null;
	}

}]);