angular.module('starter.controllers')

.controller('PinCtrl', ['$scope', '$http', '$ls', '$state', 'sync', '$ionicLoading', 'u', '$location', '$ionicModal', '$ionicViewService', function($scope, $http, $ls, $state, sync, $ionicLoading, u, $location, $ionicModal, $ionicViewService) {

	$scope.passcode = '';
	var settings = $ls.getObject('settings');
	$scope.pinHash = settings.pinHash;
	$scope.error = false;

	$scope.addPin = function(value) {
		if ($scope.passcode.length === 4 && $scope.error === true) {
			$scope.passcode = '';
			$scope.error = false;
		}

		if($scope.passcode.length < 4) {
			$scope.passcode = $scope.passcode + value;
		}

		if ($scope.passcode.length === 4) {
			$scope.checkPin();
		}
	}

	$scope.checkPin = function() {
		var hash = JSON.stringify(CryptoJS.SHA3($scope.passcode));
		if (hash === $scope.pinHash) {
			$scope.$root.justEnteredPin = true;
			var url = ($scope.$root.lastUrl) ? $scope.$root.lastUrl : '/app';
			$location.path(url);
		} else {
			$scope.error = true;
		}
	}

	$scope.deletePin = function() {
		if ($scope.error !== false) {
			$scope.passcode = '';
			$scope.error = false;
			return;
		}

		if($scope.passcode.length > 0) {
			$scope.error = false;
			$scope.passcode = $scope.passcode.substring(0, $scope.passcode.length - 1);
		}
	}

}]);