angular.module('starter.controllers')

.controller('SettingsCtrl', ['$scope', '$http', '$ls', '$state', 'sync', '$ionicLoading', 'u', '$location', '$ionicModal', function($scope, $http, $ls, $state, sync, $ionicLoading, u, $location, $ionicModal) {

	var settings = $ls.getObject('settings');
	$scope.settings = {
		requirePin: settings.requirePin
	};

	$scope.startedOff = false;

	$scope.toggleRequirePin = function() {
		settings.requirePin = $scope.settings.requirePin;
		$ls.setObject('settings', settings);

		if ($scope.settings.requirePin === true) {
			$scope.setPin();
		}
	}

	$scope.addPin = function(value) {
		if($scope.passcode.length < 4) {
			$scope.passcode = $scope.passcode + value;
		}

		if ($scope.passcode.length === 4) {
			var hash = JSON.stringify(CryptoJS.SHA3($scope.passcode));
			settings.pinHash = hash;
			$ls.set('settings', settings);

			$scope.pinModal.remove();
		}
	}

	$scope.deletePin = function() {
		if($scope.passcode.length > 0) {
			$scope.passcode = $scope.passcode.substring(0, $scope.passcode.length - 1);
		}
	}

	$scope.cancelPin = function() {
		$scope.settings.requirePin = false;
		$scope.toggleRequirePin();
		$scope.pinModal.remove();
	}


	//Cleanup the modal when we're done with it!
	$scope.$on('$destroy', function() {
		if ($scope.pinModal) {
			$scope.pinModal.remove();
		}
	});


}]);