angular.module('starter.controllers')

.controller('SigninCtrl', ['$scope', '$http', '$ls', '$ionicModal', '$location', '$ionicLoading', 'sync', 'u', '$rootScope', function($scope, $http, $ls, $ionicModal, $location, $ionicLoading, sync, u, $rootScope) {

  function signin() {
    $ionicLoading.show();

    if (!$scope.info.email || !$scope.info.password) {
      $ionicLoading.hide();
      return;
    }

    $http.post($scope.$root.uri + '/auth', $scope.info).
      success(function(data) {
				sync.resetAll().then(function(){
					var user = data.user;
					$ls.setObject('user', user);
					$ls.setArray('locations', data.locations);

					$scope.$root.hasLocations = data.locations.length > 1;
					sync.sync();
					u.setLocation();

          if ($rootScope.forceBase === true || user.id === '2') {
          	if ($rootScope.dev === true) {
	            $rootScope.base = 'http://192.168.0.6';
          	} else {
			    var ua = navigator.userAgent.toLowerCase();
			    var isAndroid = ua.indexOf("android") > -1;
				$rootScope.base = isAndroid ? 'http://freshability.com' : 'https://freshability.com';
          	}
            $rootScope.uri = $rootScope.base + '/api';
          }

          if ($scope.$root.hasLocations)  {
  					$location.url('/app/location');
          } else {
  					$location.url('/app/audit');
          }
				})

        $ionicLoading.hide();
      })
      .error(function(data) {
				if (data && data.auth && data.auth === 'Not authorized') {
	        $scope.loginError = 'Invalid username/password';
				} else {
					$scope.loginError = 'Try to log in when your device is online';
				}

        $ionicLoading.hide();
        return;
      });
  }

  function _init() {
    $scope.loginError = null;
    $scope.info = {
      email: null,
      password: null
    };

    $scope.signin = signin;
  }

  _init();

}]);