angular.module('starter').directive('action', function () {
  'use strict';

  return {
    restrict: 'E',
    templateUrl: 'templates/directive/actions.html',
    replace: true,
    scope: {
      item: '=',
      sectionInfo: '=',
      auditAction: '=',
      answer: '=',
      audit: '='
    },
    controller: ['$rootScope', '$scope', '$ionicModal', '$ls', 'sync', 'u', '$http', function ($rootScope, $scope, $ionicModal, $ls, sync, u, $http) {

      $scope.action = {};

			var user = $ls.getObject('user');

      if ($scope.auditAction) {
        $scope.action = angular.copy($scope.auditAction);
      } else {
        $scope.action = {
          audit_id: $scope.audit.id,
          audit_question_id: $scope.item.id,
          assigned_user_id: '',
          assignee_user_id: user.id,
          instructions: ''
        }
      }

      $scope.newAction  = {
        assigned_user_id: angular.copy($scope.action.assigned_user_id),
        instructions: angular.copy($scope.action.instructions)
      };

		  //Cleanup the modal when we're done with it!
		  $scope.$on('$destroy', function() {
			  if ($scope.modal) {
			    $scope.modal.remove();
			  }
		  });

      $scope.saveAction = function() {
				$scope.newAction.updated_at = u.phpts();
        $scope.action.assigned_user_id = angular.copy($scope.newAction.assigned_user_id);
        $scope.action.instructions = angular.copy($scope.newAction.instructions);

				$scope.sectionInfo.audit.actions[$scope.action.audit_question_id] = angular.copy($scope.action);
				$scope.sectionInfo.audit.actions[$scope.action.audit_question_id].updated = 1;
				sync.updateAudit($scope.sectionInfo.audit);
				$scope.modal.remove();
      }

      $scope.cancelAction = function() {
        $scope.newAction.assigned_user_id = angular.copy($scope.action.assigned_user_id);
        $scope.newAction.instructions = angular.copy($scope.action.instructions);
				$scope.modal.remove();
      }

			// Triggered on a button click, or some other target
			$scope.showPopup = function() {
				$scope.location = u.getLocation();
					$ionicModal.fromTemplateUrl('templates/directive/actionModal.html', {
						scope: $scope,
						animation: 'slide-in-up'
					}).then(function(modal) {
						$scope.modal = modal;
						$scope.modal.show();
					});
       }
    }]
  }
});
