angular.module('starter').directive('comment', function () {
  'use strict';

  return {
    restrict: 'E',
    templateUrl: 'templates/directive/comment.html',
    replace: true,
    scope: {
      item: '=',
      sectionInfo: '=',
      auditComment: '=',
      answer: '='
    },
    controller: ['$rootScope', '$scope', '$ionicModal', '$ls', 'sync', 'u', '$http', function ($rootScope, $scope, $ionicModal, $ls, sync, u, $http) {

      $scope.comment = {};

      if ($scope.auditComment) {
        $scope.comment = angular.copy($scope.auditComment);
      } else {
        $scope.comment = {
          id: null,
          audit_id: $scope.sectionInfo.audit.id,
          audit_question_id: $scope.item.id,
          guid: u.guid(),
          comment: ''
        }
      }

      $scope.newComment  = {
        comment: angular.copy($scope.comment.comment)
      };


			$scope.closeModal = function() {
				$scope.modal.remove();
			}

		  //Cleanup the modal when we're done with it!
		  $scope.$on('$destroy', function() {
			  if ($scope.modal) {
			    $scope.modal.remove();
			  }
		  });

      $scope.cancelComment = function() {
        $scope.newComment.comment = angular.copy($scope.comment.comment);
        $scope.closeModal();
      }

      $scope.saveComment = function() {
        $scope.comment.comment = angular.copy($scope.newComment.comment);
        $scope.comment.updated_at = u.phpts();

				$scope.sectionInfo.audit.comments[$scope.comment.audit_question_id] = angular.copy($scope.comment);
				$scope.sectionInfo.audit.comments[$scope.comment.audit_question_id].updated = 1;
				sync.updateAudit($scope.sectionInfo.audit);
				$scope.closeModal();
      }

       // Triggered on a button click, or some other target
       $scope.showPopup = function() {
				$ionicModal.fromTemplateUrl('templates/directive/commentModal.html', {
					scope: $scope,
					animation: 'slide-in-up'
				}).then(function(modal) {
					$scope.modal = modal;
					$scope.modal.show();
				});
       }
    }]
  }
});
