angular.module('starter').directive('fimage', function () {
  'use strict';

  return {
    restrict: 'E',
    templateUrl: 'templates/directive/fimage.html',
    replace: true,
    scope: {
      item: '=',
      sectionInfo: '=',
      auditImage: '=',
      localKey: '@'
    },
    controller: ['$rootScope', '$scope', '$ionicPopup', '$ls', 'u', '$http', 'Camera', '$window', function ($rootScope, $scope, $ionicPopup, $ls, u, $http, Camera, $window) {

			var localImages = $ls.getObject('localImages');

      $scope.image = {
	      local_uri: null,
	      remote_url: null
      };

      $scope.localImage = {
          audit_id: $scope.sectionInfo.audit.id,
          audit_guid: $scope.sectionInfo.audit.guid,
          audit_question_id: $scope.item.id,
          guid: u.guid(),
          local_uri: null,
      };

      $scope.isLocal = false;
			$scope.hasImage = false;

      if ($scope.auditImage) {
      	$scope.image.remote_url = angular.copy($scope.auditImage.remote_url);
				if (!$scope.auditImage.deleted) {
	        $scope.hasImage = true;
				}
      }

			if (localImages[$scope.localKey]) {
				$scope.localImage = localImages[$scope.localKey];
        $scope.hasImage = true;
        $scope.image.local_uri = $scope.localImage.local_uri;
			}

      $scope.saveImage = function(imageURI) {
        $scope.image.local_uri = imageURI;
        $scope.localImage.local_uri = imageURI;
        $scope.localImage.updated_at = u.phpts();

			var localImages = $ls.getObject('localImages');

				localImages[$scope.localKey] = angular.copy($scope.localImage);
				$ls.setObject('localImages', localImages);

				if ($scope.auditImage) {
					$scope.auditImage.deleted = 1;
					$scope.sectionInfo.audit.actions[$scope.action.audit_question_id] = angular.copy($scope.auditImage);
					sync.updateAudit($scope.sectionInfo.audit);
				}

				$scope.$root.needToSync = true;
				$ls.set('needToSync', true);
				$scope.hasImage = true;
      }

      $scope.deleteImage = function() {
        $scope.image.local_uri = null;
				$scope.image.deleted = 1;
				$scope.hasImage = false;
				if ($scope.localImage) {
					delete $scope.localImage;
					delete localImages[$scope.localKey];

					localImages = $ls.getObject('localImages');
					delete localImages[$scope.localKey];

					$ls.setObject('localImages', localImages);
				}
				$scope.hasImage = false;
      }

      $scope.image.local_uri = '';

      $scope.takePic = function() {
        if ($window.navigator && $window.navigator.camera) {
          Camera.getPicture(function(imageURI) {
            $scope.$apply(function(){
              $scope.saveImage(imageURI);
            });
          }, function() {
            
          }, {
            saveToPhotoAlbum: true,
            quality: 40,
            encodingType: Camera.EncodingType.JPEG,
            destinationType: Camera.DestinationType.FILE_URI,
            allowEdit: true
          });
        } else {
          $scope.saveImage('fakeUri');
					$scope.$root.needToSync = true;
					$ls.set('needToSync', true);
        }
      }

      // Triggered on a button click, or some other target
      $scope.showPopup = function() {
        if (!$scope.image.local_uri && !$scope.hasImage) {
          return $scope.takePic();
        }
     
        // An elaborate, custom popup
        var myPopup = $ionicPopup.show({
           templateUrl: 'templates/directive/fimagePopup.html',
          title: 'Image',
          subTitle: $scope.item.name,
          scope: $scope,
          buttons: [
            {
              text: 'Close',
              onTap: function(e) {
                //$scope.cancelPopup();
              }
            },
            {
              text: 'Delete',
              onTap: function(e) {
                $scope.deleteImage();
              }
            },
            {
              text: '<b>New image</b>',
              type: 'button-positive',
              onTap: function(e) {
                $scope.takePic();
              }
            },
          ]
        });
      }


    }]
  }
});
