angular.module('starter').filter('ts', function () {
  'use strict';

  return function (timestamp) {

    if (timestamp) {
      if (typeof timestamp === 'number' || timestamp.match(/^[0-9]+$/)) {

        if (timestamp.toString().length < 13) {
          timestamp = timestamp * 1000;
        }
        // If it's just a straight number
        return parseInt(timestamp, 10);
      }

      // Otherwise we need to convert it into a timestamp
      // Look for either mysql (2014-10-25 00:00:00) formatted or ISO 8601 date (2004-02-12T15:19:21+00:00)
      timestamp = timestamp.replace(/T([0-9]{2}:[0-9]{2}:[0-9]{2})-[0-9]{2}:[0-9]{2}/, ' $1');

      var parts = timestamp.split(' ');
      var dateParts = parts[0].split('-');
      var timeParts = parts[1].split(':');

      var date = new Date(dateParts[0], dateParts[1] - 1, dateParts[2], timeParts[0], timeParts[1], timeParts[2]);
      timestamp = date.getTime();

      // Return the JS timestamp
      return timestamp;
    }
    return '';
  };
});
