angular.module('ionic.utils', [])

.factory('$ls', ['$window', function($window) {
	var prefix = 'ngStorage-';

  return {
	  isset: function(key) {
		  return $window.localStorage.getItem(prefix+key) !== null
	  },
	  remove: function(key) {
		  $window.localStorage.removeItem(prefix+key);
	  },
    set: function(key, value) {
      $window.localStorage[prefix+key] = value;
    },
    get: function(key, defaultValue) {
      return $window.localStorage[prefix+key] || defaultValue;
    },
    setObject: function(key, value) {
      $window.localStorage[prefix+key] = JSON.stringify(value);
    },
		setArray: function(key, value) {
      $window.localStorage[prefix+key] = JSON.stringify(value);
		},
    getObject: function(key) {
      return JSON.parse($window.localStorage[prefix+key] || '{}');
    },
    getArray: function(key) {
      return JSON.parse($window.localStorage[prefix+key] || '[]');
    },
    $reset: function() {
	    return $window.localStorage.clear();
    }
  }
}]);
