angular.module('starter').service('u', ['$ls', '$rootScope', function ($ls, $rootScope) {
  'use strict';

  var _this = this;

  this.guid = function() {
		return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
			var r = Math.random()*16|0, v = c == 'x' ? r : (r&0x3|0x8);
			return v.toString(16);
		});
  };

	this.findAudit = function(id) {
		var audit;
		var audits = $ls.getArray('audits');

		angular.forEach(audits, function(storageAudit) {
			if (storageAudit) {
			var strStorageAuditId = String(storageAudit.id);
		    if (id === strStorageAuditId || id === storageAudit.guid) {
					audit = storageAudit;
				}
			}
		});

		return audit;
	}

	this.findAuditKey = function(id) {
		var auditKey = -1;
		var audits = $ls.getArray('audits');

		angular.forEach(audits, function(audit, key) {
			var strStorageAuditId = String(audit.id);
			if (id === strStorageAuditId || id === audit.guid) {
				auditKey = key
				return false;
			}
		});

		return auditKey;
	}

	this.findTemplate = function(id) {
		var template;
		var audit_templates = $ls.getArray('audit_templates');

    angular.forEach(audit_templates, function(storageTemplate){
      if (storageTemplate.id === id) {
				template = storageTemplate;
      }
    });

		return template;
	}

	this.findTab = function(template, tabId) {
		var returnTab;
    angular.forEach(template.tabs, function(tab){
      if (tabId == tab.id) {
        returnTab = tab;
      }
    });

		return returnTab;
	}

  this.getLocation = function() {
    var location = _this.setLocation();
    return location;
  }

  this.imgToDataURL = function(url, callback, outputFormat, quality) {
  	var canvas = document.createElement('CANVAS'),
  		ctx = canvas.getContext('2d'),
  		img = new Image();
  	img.crossOrigin = 'Anonymous';
  	img.onload = function() {
  		var dataURL;
  		canvas.height = img.height;
  		canvas.width = img.width;
  		try {
  			ctx.drawImage(img, 0, 0);
  			dataURL = canvas.toDataURL(outputFormat, quality);
  			callback(null, dataURL);
  		} catch (e) {
  			callback(e, null);
  		}
  		canvas = img = null;
  	};
  	img.onerror = function() {
  		callback(new Error('Could not load image'), null);
  	};
  	img.src = url;
  }

	this.isEastBalt = function(location) {
		if (!location) {
			return false;
		}

		if (parseInt(location.id) === 682 || parseInt(location.company_parent_id) === 682 || parseInt(location.department_company_id) === 682 || parseInt(location.company_parent_id) === 1602) {
			return true;
		} else {
			return false;
		}
	}

	this.isEastBaltBun = function(location, template) {
		if (!_this.isEastBalt(location)) {
			return false;
		}

		if (template.name.toLowerCase().match(/bun|muffin|mac/)) {
			return true;
		}

		return false;
	}

	this.phpts = function() {
		var d = new Date;
    var ts = d.getTime();
    ts = ts / 1000;
    ts = Math.round(ts);
    return ts;
	}

	this.saveRemoteImg = function (data, imageKey) {
		var auditKey = _this.findAuditKey(data.audit_id);
		if (auditKey === undefined || auditKey === null || auditKey === '' || auditKey === -1) {
			return;
		}

		var audits = $ls.getObject('audits');
		var audit = audits[auditKey];
		
		var foundImage = false;
		angular.forEach(audit.images, function(image, key) {
			if (image.audit_question_id === data.audit_question_id) {
				audit.images[key] = angular.copy(data);
				foundImage = true;
				return false;
			}
		});

		if (foundImage !== true) {
			audit.images[data.audit_question_id] = angular.copy(data);
		}

		audits[auditKey] = angular.copy(audit);

		$ls.setObject('audits', audits);

		var localImages = $ls.getObject('localImages');

		delete localImages[imageKey];

		$ls.setObject('localImages', localImages);
		$rootScope.$broadcast('syncComplete');
	}

  this.setLocationWithoutId = function() {
		var locations = $ls.getArray('locations');
		var user = $ls.getObject('user');
		var returnLocation;

    angular.forEach(locations, function(location){
      if (location.id === user.company_id) {
        $ls.set('locationId', location.id);
        returnLocation = location;
      }
    });

    return returnLocation;
  }

  this.setLocation = function() {
	  var id = $ls.get('locationId');
    var returnLocation;

		var locations = $ls.getArray('locations');
		var user = $ls.getObject('user');

    if (!id || id === 'false') {
      returnLocation = this.setLocationWithoutId();
    } else {
      angular.forEach(locations, function(location){
        if (location.id === id) {
	        $ls.set('locationId', location.id);
          returnLocation = location;
        }
      })

      if (!returnLocation) {
        returnLocation = this.setLocationWithoutId();
      }
    }

    return returnLocation;

  }

  this.uploadPhoto = function(image, callback) {
    var options = new FileUploadOptions();
    options.fileKey="file";
    options.fileName=imageURI.substr(imageURI.lastIndexOf('/')+1);
    options.mimeType="image/jpeg";
    
    var params = image;
    options.params = params;
    var ft = new FileTransfer();
    ft.upload(imageURI, encodeURI("http://some.server.com/upload.php"), callback, function(){}, options);
  }

}]);